<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "provider_form".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "ProviderForm".
 *
 * Columns in table "provider_form" available as properties of the model,
 * followed by relations of table "provider_form" available as properties of the model.
 *
 * @property integer $id
 * @property integer $provider_id
 * @property string $file_path
 * @property string $file_link
 * @property string $description
 *
 * @property Provider $provider
 */
abstract class BaseProviderForm extends BaseModel
{

    public $uploadPath;

    public function init()
    {
        parent::init();
        if (isset(Yii::app()->controller) && Yii::app()->controller->module->id == 'api') {
            $this->uploadPath = Yii::getPathOfAlias('api') . '/../providers/' . Yii::app()->params['upload_forms'];
        } else {
            $this->uploadPath = $this->basePath . Yii::app()->params['upload_forms'];
        }
    }

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'provider_form';
    }

    public static function representingColumn()
    {
        return 'description';
    }

    public function rules()
    {
        return array(
            array('provider_id', 'required'),
            array('provider_id', 'numerical', 'integerOnly' => true),
            array('file_path', 'file', 'types' => 'rtf, pdf, doc, docx, odt, jpg, jpeg, gif, png',
                'maxSize' => 1024 * 1024 * 15, 'allowEmpty' => true),
                //only files with type of 'pdf, doc, docx, odt, jpg, jpeg, gif, png' are accepted
            array('description', 'length', 'max' => 255),
            array('file_path, file_link', 'notNull'),
            array('file_link', 'url', 'defaultScheme' => 'http, https', 'message' => 'Please enter a valid link'),
            array('description', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, provider_id, file_path, description, file_link', 'safe', 'on' => 'search'),
        );
    }

    public function notNull($attribute)
    {
        if ($this->file_path == '' && $this->file_link == '') {
            $this->addError($attribute, 'Please upload a file or add a external link.');
        }
    }

    public function relations()
    {
        return array(
            'provider' => array(self::BELONGS_TO, 'Provider', 'provider_id'),
        );
    }

    public function pivotModels()
    {
        return array();
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'provider_id' => Yii::t('app', 'Provider'),
            'file_path' => Yii::t('app', 'File'),
            'file_link' => Yii::t('app', 'Link'),
            'description' => Yii::t('app', 'Description'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->with = array('provider');

        $criteria->compare('id', $this->id);

        //it will search by id or provider.first_last
        if (!intval($this->provider_id) && is_string($this->provider_id) && strlen($this->provider_id) > 0) {
            $criteria->compare('provider.first_last', $this->provider_id, true);
        } elseif (intval($this->provider_id)) {
            $criteria->compare('provider_id', $this->provider_id);
        }
        $criteria->compare('file_link', $this->file_link, true);
        $criteria->compare('file_path', $this->file_path, true);
        $criteria->compare('description', $this->description, true);

        return new CActiveDataProvider(
            get_class($this),
            array(
                'criteria' => $criteria,
                'pagination' => array('pageSize' => 100)
            )
        );
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'ProviderForm|ProviderForms', $n);
    }

}
